"use strict";
var __awaiter = (this && this.__awaiter) || function (thisArg, _arguments, P, generator) {
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : new P(function (resolve) { resolve(result.value); }).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};
Object.defineProperty(exports, "__esModule", { value: true });
const supi_1 = require("supi");
const createStoreController_1 = require("../createStoreController");
const requireHooks_1 = require("../requireHooks");
function default_1(input, opts) {
    return __awaiter(this, void 0, void 0, function* () {
        const store = yield createStoreController_1.default(opts);
        const updateOpts = Object.assign(opts, {
            allowNew: false,
            hooks: !opts.ignorePnpmfile && requireHooks_1.default(opts.prefix, opts),
            store: store.path,
            storeController: store.ctrl,
            update: true,
        });
        if (!input || !input.length) {
            return supi_1.install(updateOpts);
        }
        return supi_1.installPkgs(input, updateOpts);
    });
}
exports.default = default_1;
//# sourceMappingURL=update.js.map