"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
const getVersionSelectorType = require("version-selector-type");
function parsePref(pref, alias, defaultTag) {
    let name = alias;
    if (pref.startsWith('npm:')) {
        pref = pref.substr(4);
        const index = pref.lastIndexOf('@');
        if (index < 1) {
            name = pref;
            pref = defaultTag;
        }
        else {
            name = pref.substr(0, index);
            pref = pref.substr(index + 1);
        }
    }
    if (!name) {
        return null;
    }
    const selector = getVersionSelectorType(pref);
    if (selector) {
        return {
            fetchSpec: selector.normalized,
            name,
            type: selector.type,
        };
    }
    return null;
}
exports.default = parsePref;
//# sourceMappingURL=parsePref.js.map